/*** VisonicPowerMax Z-Way HA module *******************************************


// ----------------------------------------------------------------------------
// --- Module methods
// ----------------------------------------------------------------------------

VisonicPowerMax.prototype.login = function() {
    debugPrint("VisonicPowerMax login()");

    var self = this;
    var req = {
        url: "http://192.168.1.200/web/ajax/login.login.ajax.php",
        method: "POST",
        data: {
            user: self.config.login,
            pass: self.config.password
        },
    };
    req.headers = {'Connection': 'keep-alive'};
    var resp = http.request(req);
    debugPrint("VisonicPowerMax login resp " + JSON.stringify(resp));
    debugPrint("VisonicPowerMax Cookie:" + resp.headers["Set-Cookie"]);
    self.cookie = resp.headers["Set-Cookie"].split(';')[0];
    self.sesid = self.cookie.split('=')[1];
    debugPrint("VisonicPowerMax self.cookie:" + self.cookie);
    debugPrint("VisonicPowerMax self.sesid:" + self.sesid);

}

VisonicPowerMax.prototype.update = function (vDev) {
    var self = this,
        deviceType = vDev.get("deviceType"),
        url = this.config["getter_" + deviceType],
        parser = this.config["getterParser_" + deviceType];

    debugPrint("VisonicPowerMax update() cookie="+self.cookie);

    if (url) {
        var req = {
            url: url + (!self.alarmCurIndex ? '' : '?curindex=' + self.alarmCurIndex),
            method: "GET",
            async: true,
            
            error: function(response) {
                console.log("VisonicPowerMax error: Can not make request: " + response.statusText); // don't add it to notifications, since it will fill all the notifcations on error
            },
            complete: function(response) {
                //<reply><customStatus>[NOCNG]</customStatus></reply>
                if (self.alarmCurIndex != null) {
                    var cng = response.data.findOne("/reply/customStatus/text()");
                    if (cng === '[NOCNG]') {
                        self.log("No change in alarm status");
                        self.log("[NOCNG] Response received:" + response.data);
                        return;
                    }
                }
                self.log("Possibly a change.  Response received:" + response.data);

                var newIndex = response.data.findOne("/reply/index/text()");
                self.log("newIndex=" + newIndex + "   prev=" + self.alarmCurIndex);
                self.alarmStatus = response.data.findOne("/reply/configuration/system/status/text()");
                if (self.alarmStatus == null) {
                    self.alarmStatus = response.data.findOne("/reply/update/system/status/text()");
                }

                var metricsLevel = self.alarmStatus === "AWAY" ? "on" : "off";
                self.log(vDev.deviceId + '.set("metrics:level", ' + metricsLevel + ")");
                vDev.set("metrics:level", metricsLevel);
                if (newIndex != null && newIndex != undefined) {
                    self.alarmCurIndex = newIndex;
                }
                self.log("status=" + self.alarmStatus);
            }
        };

        req.headers = {
            "Content-Type": self.config.contentType,
            "Cookie": self.cookie
        };

        self.log("Request url=" + req.url);
        var resp = http.request(req);

    }
};

VisonicPowerMax.prototype.log = function(info) {
    console.log('['+this.constructor.name+'-'+this.id+'] ' + info);
}

};
